﻿
/* Déclaration des variables  */
var geocoder;
var map;
var marker;
var markers = new Array;
var detect = navigator.userAgent.toLowerCase();

function onLoad() {
  var reg = new RegExp('/', "g");

  if (coordinates.ADRESSE)
    coordinates.ADRESSE = coordinates.ADRESSE.replace("/", ", ");

  document.getElementById("match").value = coordinates.ADRESSE;
  geocoder = new google.maps.Geocoder();
  var mapElement = document.getElementById("map");
  if (coordinates.LAT <= 90 && coordinates.LAT != " " && coordinates.LAT != "") {

  } else {
    coordinates.LAT = 49; coordinates.LON = 3;
    coordinates.ZOOM = coordinates.ZOOM | 18;
    geocoder.geocode({ 'address': coordinates.ADRESSE }, function (results, status) {
      /* Si l'adresse a pu être géolocalisée */
      if (status == google.maps.GeocoderStatus.OK) {
        /* Récupération de sa latitude et de sa longitude */
        coordinates.LAT = results[0].geometry.location.lat();
        coordinates.LON = results[0].geometry.location.lng();
        LatLng = new google.maps.LatLng(coordinates.LAT, coordinates.LON);
        updateMarkerPosition(LatLng);
        geocodePosition(LatLng);
      }
    });


  }
  zoom = coordinates.ZOOM;
  LatLng = new google.maps.LatLng(coordinates.LAT, coordinates.LON);


  /*
  MapTypeId.ROADMAP affiche un plan (de type carte routière).
  MapTypeId.SATELLITE affiche une vue satellite.
  MapTypeId.HYBRID affiche une vue mixte entre les deux précédentes.
  MapTypeId.TERRAIN affiche une vue du relief.
  */
  var mapOpts = {
    center: LatLng,
    zoom: zoom,
    mapTypeId: google.maps.MapTypeId.SATELLITE
  };

  map = new google.maps.Map(mapElement, mapOpts);




  if (coordinates)
    marker = new google.maps.Marker({
      position: map.getCenter(),
      map: map,
      draggable: true
    });


  // Add dragging event listeners.    
  google.maps.event.addListener(marker,
        'dragstart',
        function () {
          updateMarkerAddress('Dragging...');
        });

  google.maps.event.addListener(marker,
            'drag',
            function () {
              updateMarkerStatus('Dragging...');
              updateMarkerPosition(marker.getPosition());
            }
            );

  google.maps.event.addListener(marker,
                                            'dragend',
                                            function () {



                                              // getElevation({ latLng: marker.getPosition() });
                                              geocodePosition(marker.getPosition());
                                              updateMarkerStatus('Drag ended');
                                              getElevation({ 'latLng': marker.getPosition() });


                                            }
        );

  // styleIcon = new StyledIcon(StyledIconTypes.BUBBLE, { color: "#cccccc", text: "Drag Me!" });
  // var styleMaker1 = new StyledMarker({ styleIcon: styleIcon, position: new google.maps.LatLng(37.383477473067, -121.880502070713), map: map, draggable: true });

  // google.maps.event.addDomListener(styleMaker1, "dragend", getElevation);
  // Update current position info.    

  updateMarkerPosition(LatLng);
  geocodePosition(LatLng);
  getElevation({ 'latLng': marker.getPosition() });

  return false;





}

function updateMarkerStatus(str) {
  document.getElementById('markerStatus').innerHTML = str;
}

function updateMarkerPosition(latLng) {
  document.Envoie.lat.value = latLng.lat();
  document.Envoie.lon.value = latLng.lng();
  dms_frac = dec2dms(latLng.lng());
  if (document.Envoie.lon.value < 0)
    document.Envoie.lonRef.value = "W";
  else
    document.Envoie.lonRef.value = "E";
  document.Envoie.lonDMS.value = Math.abs(dms_frac.Degre) + "/1" + " " + dms_frac.Minute + "/1" + " " + dms_frac.Numerator + "/" + dms_frac.Denominator;
  dms_frac = dec2dms(latLng.lat());
  if (document.Envoie.lat.value < 0)
    document.Envoie.latRef.value = "S";
  else
    document.Envoie.latRef.value = "N";
  document.Envoie.latDMS.value = Math.abs(dms_frac.Degre) + "/1" + " " + dms_frac.Minute + "/1" + " " + dms_frac.Numerator + "/" + dms_frac.Denominator;
  //  update_datas();
}

function update_datas() {
  n = jQuery(document.EditJPEG);
  jQuery.each(n[0], function (i) {
    n00 = this;
    n0 = n00.id;
    n1 = n00.name;
    n2 = jQuery(n00).val();
    try {
      if (n0 == "alt") {
        n3 = dec2frac(document.Envoie[n0].value);
        n3 = n3.Numerator + "/" + n3.Denominator;
        jQuery(this).val(n3);
      }
      else {
        n3 = document.Envoie[n0].value;
        jQuery(this).val(n3);
      }
    }
    catch (e) {
      n3 = n0;
    }
  })
}

function updateMarkerAddress(str) {
  document.getElementById('markerAdress').innerHTML = str;
  jQuery("#match").val(str);
}

function getElevation(event) {
  var elevator = new google.maps.ElevationService();
  var locations = [];

  // Retrieve the clicked location and push it on the array
  var clickedLocation = event.latLng;
  locations.push(clickedLocation);

  // Create a LocationElevationRequest object using the array's one value
  var positionalRequest = {
    'locations': locations
  }

  // Initiate the location request
  if (elevator) {
    elevator.getElevationForLocations(positionalRequest, function (results, status) {
      if (status == google.maps.ElevationStatus.OK) {

        // Retrieve the first result
        if (results[0]) {
          coordinates.ALT = results[0].elevation;
          document.Envoie.alt.value = coordinates.ALT;
          altDMS = dec2frac(coordinates.ALT);
          document.Envoie.altRef.value = "0";

          document.Envoie.altDMS.value = altDMS.Numerator + "/" + altDMS.Denominator;
          //styleIcon.set("text", "Elevation: " + results[0].elevation + "m");
        } else {
          // alert("No results found");
        }
      } else {
        alert("Elevation service failed due to: " + status);
      }
    });
  }
}
function geocodePosition(pos) {
  geocoder.geocode({ 'latLng': pos },
                    function (results, status) {
                      /* Si le géocodage inversé a réussi */
                      if (status == google.maps.GeocoderStatus.OK) {
                        updateMarkerAddress(results[0].formatted_address);
                      } else {
                        updateMarkerAddress('Cannot determine address at this location.');
                      }
                    });
}
/* Fonction de géocodage déclenchée en cliquant surle bouton "Geocoder"  */
function codeAddress() {
  /* Récupération de la valeur de l'adresse saisie */

  /* Appel au service de geocodage avec l'adresse en paramètre */
  if (typeof map == "undefined") onLoad();

  var address = document.getElementById("match").value;

  geocoder.geocode({ 'address': address }, function (results, status) {
    /* Si l'adresse a pu être géolocalisée */
    if (status == google.maps.GeocoderStatus.OK) {
      /* Récupération de sa latitude et de sa longitude */
      coordinates.LAT = results[0].geometry.location.lat();
      coordinates.LON = results[0].geometry.location.lng();
      onLoad();
    } else {
      alert("Cannot determine location at this adress.: " + status);
    }
  });
}

//=======================================================
function On_Click(a, b, c) {
  document.Envoie.lat.value = b;
  document.Envoie.lon.value = c;
  coordinates = { LAT: a,
    LON: b
  };
  LatLng = new google.maps.LatLng(coordinates.LAT, coordinates.LON);
  updateMarkerPosition(LatLng);
}

jQuery(window).load(
      function () {
        //Récupérer tous les inputs radios appartenant à un même groupe
        /*         a = jQuery('input[type=hidden][name=Selectthumbnail]');
        b = a.length;
        c = jQuery('input[type=hidden]:checked').length;
        d = jQuery('input[type=hidden][name="Selectthumbnail"]').attr('value'); 
        */

        //  onLoad();
      });

jQuery(document).ready(function () {

 /*
  jQuery('.cluetip').cluetip({
    width: 300, height: 100,
    splitTitle: '|',
    clickThrough: true
  }
  );
  */
  jQuery('.cluetip').tipTip({ maxWidth: '600px', 'delay': 0, 'fadeIn': 200, 'fadeOut': 200 });  
  jQuery("#search").click(function (e) {

    coordinates = { ADRESSE: jQuery("#match").val(),
      LAT: 0, LON: 0, ZOOM: 18, ALT: 0
    };
    codeAddress();
    return false;
  });

  jQuery("#match").keydown(function (e) {
    // e.target         pour FireFox
    // event.srcElement pour IE
    var Obj = e ? e.target : event.srcElement;
    if (Obj.tagName != "INPUT") return false;
    var Code = e.keyCode || e.which;
    if (Code != 13) return true;
    coordinates = { ADRESSE: jQuery("#match").val(),
      LAT: 0, LON: 0, ZOOM: 18, ALT: 0
    };
    codeAddress();
    return false;
  });


});




// DECIMAL TO FRACTION
//
function dec2frac(valeur_decimal) {
  decimal = valeur_decimal.toString();
  num = '';
  den = 1;
  dec = false;

  // find least reduced fractional form of number
  for (i = 0, ix = decimal.length; i < ix; i++) {
    // build the denominator as we 'shift' the decimal to the right
    if (dec) den *= 10;

    // find the decimal place/ build the numberator
    if (decimal.charAt(i) == '.') dec = true;
    else num += decimal.charAt(i);
  }
  num = parseInt(num);

  // whole number, just return it
  if (den == 1) return num;

  num2 = num;
  den2 = den;
  rem = 1;
  // Euclid's Algorithm (to find the gcd)
  while (num2 % den2) {
    rem = num2 % den2;
    num2 = den2;
    den2 = rem;
  }
  if (den2 != den) rem = den2;
  ret1 = { Numerator: (num / rem), Denominator: (den / rem) };
  // new Array()
  // ret1->Numerator =(num / rem ) ;
  // ret1->Denominator=(den / rem);

  // now $rem holds the gcd of the numerator and denominator of our fraction
  return ret1;

}

function dec2dms(l) {
  sign = 1;
  if (l < 0) { sign = -1; }
  l = Math.abs(Math.round(l * 1000000.))
  d = Math.floor(l / 1000000) * sign;
  m = Math.floor(((l / 1000000) - Math.floor(l / 1000000)) * 60);
  s = Math.floor(((((l / 1000000) - Math.floor(l / 1000000)) * 60) - Math.floor(((l / 1000000) - Math.floor(l / 1000000)) * 60)) * 100000) * 60 / 100000;
  frac_s = dec2frac(s);
  s2 = (frac_s.Numerator / frac_s.Denominator);
  return { dms: d + "° " + m + "' " + s + "''",
    Degre: d, Minute: m, Sec: s,
    Numerator: frac_s.Numerator,
    Denominator: frac_s.Denominator
  };
}

